//+------------------------------------------------------------------+
//|                                                     iRSIUSDx.mq5 |
//|                                            Copyright 2010, Lizar |
//|                            https://login.mql5.com/ru/users/Lizar |
//+------------------------------------------------------------------+
#define VERSION       "1.00 Build 2 (7 Jan 2011)"

#property copyright   "Copyright 2010, Lizar"
#property link        "https://login.mql5.com/ru/users/Lizar"
#property version     VERSION
#property description "  \"RSI   \" iRSIUSDx."
#property description "        \"Control panel MCM\""

//----  :
#property indicator_separate_window        //     
#property indicator_plots 7                //  7 b[ z
#property indicator_buffers 7              //  7 
#property indicator_color1 Violet          //     
#property indicator_color2 Red             //     
#property indicator_color3 Blue            //     
#property indicator_color4 Yellow          //     
#property indicator_color5 Green           //     
#property indicator_color6 Gray            //     
#property indicator_color7 Red             //     
#property indicator_width7 2

#include <Control panel MCM.mqh> //<---   Control panel MCM
#include "iRSI USDx.mqh"

input int count=500; //    
input int period=14; //  

double iRSIUSDx_Ind[]; //   RSI   

string   currency="USD"; //  
int      symbol_total=6; //      
int      calculate=0;

CRSIUSDx *buffer[];  //       
                     //    RSI  
                     //      .
                     
//---           :
stCurrencyWeight currency_weight[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {   
   //---  Control panel MCA. 
   InitControlPanelMCM();

   //---   :
   ArrayResize(buffer,symbol_total);
   ArrayResize(currency_weight,symbol_total);
   
   //---         
   //       :
   currency_weight[0].symbol ="EURUSD"; currency_weight[0].weight =0.576;
   currency_weight[1].symbol ="USDJPY"; currency_weight[1].weight =0.136;
   currency_weight[2].symbol ="GBPUSD"; currency_weight[2].weight =0.119;
   currency_weight[3].symbol ="USDCAD"; currency_weight[3].weight =0.091;
   currency_weight[4].symbol ="USDSEK"; currency_weight[4].weight =0.042;
   currency_weight[5].symbol ="USDCHF"; currency_weight[5].weight =0.036;

   //--- indicator buffers mapping
   for(int i=0; i<symbol_total; i++)
     {
      buffer[i]=new CRSIUSDx;
      SetIndexBuffer(i,buffer[i].buffer,INDICATOR_DATA); //   RSI i- 
      buffer[i].SetCurrencyAndWeight(currency_weight[i].symbol, currency_weight[i].weight);
      if(!buffer[i].Init(i,count,period,currency)) return(1);         
     }
   SetIndexBuffer     (6,iRSIUSDx_Ind,INDICATOR_DATA);  //  iRSIUSDx_Ind[]   
   PlotIndexSetString (6,PLOT_LABEL,"iRSI USDx");
   PlotIndexSetInteger(6,PLOT_DRAW_TYPE,DRAW_LINE);
   ArraySetAsSeries   (iRSIUSDx_Ind,true);              //    iRSIUSDx_Ind[]     

   //--- set accuracy
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits);
   
   //--- name for DataWindow and indicator subwindow label
   IndicatorSetString(INDICATOR_SHORTNAME,"iRSI USDx "+VERSION);
   
//--- set levels
   IndicatorSetInteger(INDICATOR_LEVELS,3);
   IndicatorSetDouble(INDICATOR_LEVELVALUE,0,30);
   IndicatorSetDouble(INDICATOR_LEVELVALUE,1,500);
   IndicatorSetDouble(INDICATOR_LEVELVALUE,2,70);
   IndicatorSetInteger(INDICATOR_LEVELSTYLE,0,STYLE_DOT);
   IndicatorSetInteger(INDICATOR_LEVELSTYLE,1,STYLE_DOT);
   IndicatorSetInteger(INDICATOR_LEVELSTYLE,2,STYLE_DOT);
//--- set maximum and minimum for subwindow 
   IndicatorSetDouble(INDICATOR_MINIMUM,0);
   IndicatorSetDouble(INDICATOR_MAXIMUM,100);

   return(0);
  }

//+------------------------------------------------------------------+
//|    .     |
//|    ,    .        |
//|                                                                  |
//|   Control panel MCM            |
//|  .                                         |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,         //       " "+CHARTEVENT_CUSTOM  
                  const long& lparam,   //  
                  const double& dparam, // 
                  const string& sparam  //  
                 )
  {
   int custom_id=id-CHARTEVENT_CUSTOM-1;
   
   if(custom_id>=0)      
     {
      if(lparam!=CHARTEVENT_NEWBAR_NO)
        { 
         //---    :
         if(EventToPeriod(lparam)==_Period && sparam==_Symbol)
           { //         
            iRSIUSDx_Ind[0]=EMPTY_VALUE;
            //---   RSI       
            for(int i=0;i<symbol_total;i++) buffer[i].Refresh();
            iRSIUSDx(symbol_total);    //     RSI  
            return;
           }
         
         buffer[custom_id].Refresh();  //  RSI  custom_id     
         iRSIUSDx(symbol_total);       //     RSI  
         return;
        }
      else 
        { 
         //---     "" 
         buffer[custom_id].RefreshBuffer();     //    RSI  custom_id  
         Init_iRSIUSDx(symbol_total,calculate); //    RSI  
         return;
        }
     }
  }
   
//+------------------------------------------------------------------+
//|                           |
//| INPUT:  total       - r    ;     |
//|         count_iUSDx -    .              |
//| OUTPUT: no.                                                      |
//| REMARK: no.                                                      |
//+------------------------------------------------------------------+
void Init_iRSIUSDx(int total, int count_iUSDx)
  {   
   for(int bar=count_iUSDx-1; bar>=0; bar--) iRSIUSDx(total,bar);     
   return;
  }

//+------------------------------------------------------------------+
//|               |
//| INPUT:  total  - r    ;          |
//|         bar    -    .                         |
//| OUTPUT: no.                                                      |
//| REMARK: no.                                                      |
//+------------------------------------------------------------------+
void iRSIUSDx(int total, int bar=0)
  {
   iRSIUSDx_Ind[bar]=1;
   for(int i=0;i<total;i++) 
     if(buffer[i].buffer[bar]!=EMPTY_VALUE && buffer[i].GetInit()) 
       {
         double value_rsi=buffer[i].buffer[bar];
         iRSIUSDx_Ind[bar]*=MathPow(buffer[i].GetFlag()*(100.0 - 2.0*value_rsi)+value_rsi,buffer[i].GetWeight());
       }
     else { iRSIUSDx_Ind[bar]=EMPTY_VALUE; return; }   
//   if(iRSIUSDx_Ind[bar]<5) iRSIUSDx_Ind[bar]=EMPTY_VALUE;
   return;
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total, const int prev_calculated, const int begin, const double &price[]) 
  {
   if(prev_calculated==0)
     {
      ArrayInitialize(iRSIUSDx_Ind,EMPTY_VALUE); 
      calculate=MathMin(rates_total,TerminalInfoInteger(TERMINAL_MAXBARS));   
      calculate=MathMin(calculate,count);
     }
   
   //---       ,
   //         :
   if(isNewBar())
     {
      iRSIUSDx_Ind[0]=EMPTY_VALUE;
      for(int i=0;i<symbol_total;i++) buffer[i].buffer[0]=EMPTY_VALUE;
      ChartRedraw();
     }
   
   return(rates_total);
  }

//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   for(int i=0;i<symbol_total;i++) delete buffer[i];   
   DeinitControlPanelMCM();   //<---  Control panel MCA
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|  true,       /  |
//+------------------------------------------------------------------+
bool isNewBar()
  {
//---         
   static datetime last_time=0;
//---  
   datetime lastbar_time=(datetime)SeriesInfoInteger(Symbol(),Period(),SERIES_LASTBAR_DATE);

//---     
   if(last_time==0)
     {
      //---     
      last_time=lastbar_time;
      return(false);
     }

//---   
   if(last_time!=lastbar_time)
     {
      //---     true
      last_time=lastbar_time;
      return(true);
     }
//---     -    ,  false
   return(false);
  }