//+------------------------------------------------------------------+
//|                                                    iRSI USDx.mqh |
//|                                            Copyright 2010, Lizar |
//|                            https://login.mql5.com/ru/users/Lizar |
//|                                              Revision 2010.01.03 |
//+------------------------------------------------------------------+

//           
struct stCurrencyWeight
{
   string symbol;   // 
   double weight;   // 
};

#include "CSynchronizedBufferRSI.mqh"

//+------------------------------------------------------------------+
//| Class CRSIUSDx                                                   |
//| Appointment:            |
//|        RSI    |
//|       RSI                             | 
//+------------------------------------------------------------------+
class CRSIUSDx : public CSynchronizedBufferRSI
  {
   protected:
      double   m_currency_weight;   //    
      int      m_currency_base_flag;//  0 -  
                                    //  1 -  
                                    // -1 -   
   public:
      //---  :
      bool Init(int n,int rsi_count, int rsi_period, string currency_index);
      //---  /  :
      void     SetCurrencyAndWeight(string symbol, double weight);
      double   GetWeight() {return(m_currency_weight);}
      int      GetFlag()   {return(m_currency_base_flag);}
  };
  
//+------------------------------------------------------------------+
//|               |
//|   .                                       |
//| INPUT:  symbol - ;                                         |
//|         weight -  .                             |
//| OUTPUT: no.                                                      |
//| REMARK: no.                                                      |
//+------------------------------------------------------------------+
void CRSIUSDx::SetCurrencyAndWeight(string symbol, double weight)
  {
   m_symbol=symbol;
   m_currency_weight=weight;
  }
  
//+------------------------------------------------------------------+
//|    RSI                               |
//| INPUT:  n              -   ;                |
//|         currency_index -  ;                         |
//|         rsi_count      -     ;|
//|         rsi_period     -               |
//| OUTPUT: true  -                       |
//|         false -                                         |
//| REMARK: no.                                                      |
//+------------------------------------------------------------------+
bool CRSIUSDx::Init(int n,int rsi_count, int rsi_period, string currency_index)
  {   
   
   //---      :
   if(currency_index==SymbolInfoString(m_symbol,SYMBOL_CURRENCY_BASE)) m_currency_base_flag=0;
   else if(currency_index==SymbolInfoString(m_symbol,SYMBOL_CURRENCY_PROFIT)) m_currency_base_flag=1;
        else m_currency_base_flag=-1;

   //---  
   Init(n,m_symbol,rsi_count,rsi_period);
   
   return(true);
  }